unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NetWorks, MyNetWorks, XPMan, ComCtrls, ImgList,
  ExtCtrls, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient;

const
   PM_DOMAINS                  =         WM_USER + 1;
   PM_GROUPS                   =         WM_USER + 2;
   PM_USERS                    =         WM_USER + 3;
   PM_COMPS                    =         WM_USER + 4;
   PM_SHARES                   =         WM_USER + 5;
   PM_TRANSPORTS               =         WM_USER + 6;
   PM_IP                       =         WM_USER + 7;
   PM_DOMTHREADDONE            =         WM_USER + 8;
   PM_GRPTHREADDONE            =         WM_USER + 9;
   PM_CMPTHREADDONE            =         WM_USER + 10;
   PM_USRTHREADDONE            =         WM_USER + 11;
   PM_SHRTHREADDONE            =         WM_USER + 12;
   PM_TRPTHREADDONE            =         WM_USER + 13;
   PM_IPTHREADDONE             =         WM_USER + 14;

type

  // --- DomThread ---
  TDomThread = class(TThread)
  constructor Create(CreateSuspended: Boolean);
  private
    { Private declarations }
    What:           integer;
    dom:            string;
    pdc:            string;
    procedure ShowInfo;
  protected
    procedure Execute; override;
  end;
  // -------------------------

  // --- UsrThread ---
  TUsrThread = class(TThread)
  constructor Create(CreateSuspended: Boolean);
  private
    { Private declarations }
    What:           integer;
    dom:            string;
    pdc:            string;
    Node:           TTreeNode;
    procedure ShowInfo;
  protected
    procedure Execute; override;
  end;
  // -------------------------

  // --- GrpThread ---
  TGrpThread = class(TThread)
  constructor Create(CreateSuspended: Boolean);
  private
    { Private declarations }
    What:           integer;
    dom:            string;
    pdc:            string;
    Node:           TTreeNode;
    UsrThread:      TUsrThread;
    procedure ShowInfo;
  protected
    procedure Execute; override;
  end;
  // -------------------------

  // --- CmpThread ---
  TCmpThread = class(TThread)
  constructor Create(CreateSuspended: Boolean);
  private
    { Private declarations }
    What:           integer;
    dom:            string;
    pdc:            string;
    Node:           TTreeNode;
    procedure ShowInfo;
  protected
    procedure Execute; override;
  end;
  // -------------------------

  // --- ShrThread ---
  TShrThread = class(TThread)
  constructor Create(CreateSuspended: Boolean);
  private
    { Private declarations }
    What:           integer;
    computer:       string;
    Node:           TTreeNode;
    procedure ShowInfo;
  protected
    procedure Execute; override;
  end;
  // -------------------------

  // --- TrpThread ---
  TTrpThread = class(TThread)
  constructor Create(CreateSuspended: Boolean);
  private
    { Private declarations }
    What:           integer;
    computer:       string;
    Node:           TTreeNode;
    procedure ShowInfo;
  protected
    procedure Execute; override;
  end;
  // -------------------------

  // --- IpThread ---
  TIpThread = class(TThread)
  constructor Create(CreateSuspended: Boolean);
  private
    { Private declarations }
    What:           integer;
    computer:       string;
    Node:           TTreeNode;
    procedure ShowInfo;
  protected
    procedure Execute; override;
  end;
  // -------------------------



  TMain = class(TForm)
    Button1: TButton;
    NW: TMyNetWorks;
    I32: TImageList;
    Tree: TTreeView;
    XPMan: TXPManifest;
    Panel1: TPanel;
    User: TEdit;
    Comp: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Status: TStatusBar;
    Log: TMemo;
    Splitter1: TSplitter;
    Timer: TTimer;
    Wrk: TLabel;
    UsrGroups: TCheckBox;
    UsrComment: TCheckBox;
    ShrPath: TCheckBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;

    procedure MsgDomThreadDone( var AMessage: TMessage); message PM_DOMTHREADDONE;
    procedure MsgGrpThreadDone( var AMessage: TMessage); message PM_GRPTHREADDONE;
    procedure MsgCmpThreadDone( var AMessage: TMessage); message PM_CMPTHREADDONE;
    procedure MsgUsrThreadDone( var AMessage: TMessage); message PM_USRTHREADDONE;
    procedure MsgShrThreadDone( var AMessage: TMessage); message PM_SHRTHREADDONE;
    procedure MsgTrpThreadDone( var AMessage: TMessage); message PM_TRPTHREADDONE;
    procedure MsgIpThreadDone( var AMessage: TMessage); message PM_IPTHREADDONE;
    procedure MsgDomains( var AMessage: TMessage); message PM_DOMAINS;
    procedure MsgGroups( var AMessage: TMessage); message PM_GROUPS;
    procedure MsgUsers( var AMessage: TMessage); message PM_USERS;
    procedure MsgComps( var AMessage: TMessage); message PM_COMPS;
    procedure MsgShares( var AMessage: TMessage); message PM_SHARES;
    procedure MsgTransports( var AMessage: TMessage); message PM_TRANSPORTS;
    procedure MsgIP( var AMessage: TMessage); message PM_IP;


    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function  FindGrp( g: TTreeNode; gID: integer ): TTreeNode;
    function  GetGID( str: string ): integer;
    procedure ToLog(str: string);
    procedure TimerTimer(Sender: TObject);
    procedure DNSStatus(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: String);
  private
    { Private declarations }
  public
    { Public declarations }
    ThreadCnt:            cardinal;
  end;

var
  Main:                    TMain;

implementation

{$R *.dfm}

procedure TMain.MsgDomThreadDone( var AMessage: TMessage);
begin
   if AMessage.WParam <> 0 then
      FreeAndNil( TDomThread(AMessage.WParam) );
   Status.Simpletext := 'Domains Information complete';
   dec( ThreadCnt );
end;

procedure TMain.MsgGrpThreadDone( var AMessage: TMessage);
var
   UsrThread:                     TUsrThread;
begin
   if AMessage.WParam <> 0 then
      FreeAndNil( TGrpThread(AMessage.WParam) );
   Status.Simpletext := 'Groups Information complete';

   if AMessage.LParam <> 0 then
      UsrThread := TUsrThread( AMessage.LParam );
         UsrThread.Resume;
   dec( ThreadCnt );
end;

procedure TMain.MsgCmpThreadDone( var AMessage: TMessage);
begin
   if AMessage.WParam <> 0 then
      FreeAndNil( TCmpThread(AMessage.WParam) );
   Status.Simpletext := 'Computers Information complete';
   dec( ThreadCnt );
end;

procedure TMain.MsgUsrThreadDone( var AMessage: TMessage);
begin
   if AMessage.WParam <> 0 then
      FreeAndNil( TUsrThread(AMessage.WParam) );
   Status.Simpletext := 'Users Information complete';
   dec( ThreadCnt );
end;

procedure TMain.MsgShrThreadDone( var AMessage: TMessage);
begin
   if AMessage.WParam <> 0 then
      FreeAndNil( TShrThread(AMessage.WParam) );
   Status.Simpletext := 'Shares Information complete for a computer';
   dec( ThreadCnt );
end;

procedure TMain.MsgTrpThreadDone( var AMessage: TMessage);
begin
   if AMessage.WParam <> 0 then
      FreeAndNil( TTrpThread(AMessage.WParam) );
   Status.Simpletext := 'Transports Information complete for a computer';
   dec( ThreadCnt );
end;

procedure TMain.MsgIpThreadDone( var AMessage: TMessage);
begin
   if AMessage.WParam <> 0 then
      FreeAndNil( TIpThread(AMessage.WParam) );
   Status.Simpletext := 'IP Information complete for a computer';
   dec( ThreadCnt );
end;



procedure TMain.MsgDomains( var AMessage: TMessage);
var
   nDom, gCmp, gGrp:               TTreeNode;
   d, c:                           TThreadList;
   i:                              integer;
   dom:                            string;
   GrpThread:                      TGrpThread;
   CmpThread:                      TCmpThread;
   UsrThread:                      TUsrThread;

begin
   d := nil; c := nil;
   if AMessage.LParam <> 0 then begin
      d := TThreadList( AMessage.LParam );
      c := TThreadList( AMessage.WParam );
      with d.LockList do begin
         if Count > 0 then begin
            for i := 0 to Count - 1 do begin
               nDom := Tree.Items.Add( nil, PMyNetResource( Items[i] )^.RemoteName+' (Comment: '+PMyNetResource( Items[i] )^.Comment+') (Provider: '+PMyNetResource( Items[i] )^.Provider+')' );
               nDom.ImageIndex := 0;
               nDom.SelectedIndex := 0;
               nDom.StateIndex := 0;

               gCmp := Tree.Items.AddChild( nDom, 'Computers' );
               gCmp.ImageIndex := 11;
               gCmp.SelectedIndex := 11;
               gCmp.StateIndex := 11;

               gGrp := Tree.Items.AddChild( nDom, 'User Groups' );
               gGrp.ImageIndex := 4;
               gGrp.SelectedIndex := 4;
               gGrp.StateIndex := 4;


               if Assigned( c ) then begin
                  dom := PMyNetResource(Items[i])^.RemoteName;
                  with c.LockList do begin
                     if Count = 1 then begin
                        // Users thread
                        UsrThread := TUsrThread.Create( True );
                        UsrThread.pdc := PMyNetResource(Items[0])^.RemoteName;
                        UsrThread.Node := gGrp;
                        //UsrThread.Resume; (will be resumed after GrpThread terminated)
                        inc( ThreadCnt );
                        UsrGroups.Enabled := False;
                        UsrComment.Enabled := False;


                        // Group thread
                        GrpThread := TGrpThread.Create( True );
                        GrpThread.pdc := PMyNetResource(Items[0])^.RemoteName;
                        GrpThread.dom := dom;
                        GrpThread.Node := gGrp;
                        GrpThread.UsrThread := UsrThread;
                        GrpThread.Resume;
                        inc( ThreadCnt );

                        // Comps thread
                        CmpThread := TCmpThread.Create( True );
                        CmpThread.pdc := PMyNetResource(Items[0])^.RemoteName;
                        CmpThread.dom := dom;
                        CmpThread.Node := gCmp;
                        CmpThread.Resume;
                        inc( ThreadCnt );
                     end;
                     c.UnlockList;
                  end;
               end;


            end;
         end;
         d.UnlockList;
      end;
   end; {if AMessage.LParam <> 0 then begin}
   if Assigned( d ) then
      NW.FreeAndNilList( d );
   if Assigned( c ) then
      NW.FreeAndNilList( c );
end;

procedure TMain.MsgGroups( var AMessage: TMessage);
var
   n, parNode:             TTreeNode;
   g:                      TThreadLIst;
   i:                      cardinal;
begin
   g := nil;
   if ( (AMessage.WParam <> 0) and (AMessage.LParam <> 0) ) then begin
      parNode := TTreeNode( AMessage.WParam );
      g := TThreadList( AMessage.LParam );
      with g.LockList do begin
         if Count > 0 then
            for i := 0 to Count - 1 do begin
               n := Tree.Items.AddChild( parNode, '|'+IntToStr(PMyNetGroup(Items[i])^.gID)+'| '+PMyNetGroup(Items[i])^.Name+' ('+PMyNetGroup(Items[i])^.Comment+')' );
               n.ImageIndex := 9;
               n.SelectedIndex := 9;
               n.StateIndex := 9;
            end;
         g.UnlockList;
      end;
   end;
   if Assigned( g ) then
      NW.FreeAndNilList( g );
end;

procedure TMain.MsgComps( var AMessage: TMessage);
var
   nn, n, parNode:         TTreeNode;
   g:                      TThreadLIst;
   i:                      cardinal;
   pns:                    PMyNetSrv;
   ShrThread:              TShrThread;
   TrpThread:              TTrpThread;
   IpThread:               TIpThread;
begin
   g := nil;
   if ( (AMessage.WParam <> 0) and (AMessage.LParam <> 0) ) then begin
      parNode := TTreeNode( AMessage.WParam );
      g := TThreadList( AMessage.LParam );
      with g.LockList do begin
         if Count > 0 then
            for i := 0 to Count - 1 do begin
               pns := Items[I];
               // Adding a computer name
               n := Tree.Items.AddChild( parNode, pns^.Name+' ('+pns^.Comment+')' );
               if (pns^.Tip and SV_TYPE_DOMAIN_CTRL <> 0) then begin
                  n.ImageIndex := 12;
                  n.SelectedIndex := 12;
                  n.StateIndex := 12;
               end
               // look for OS (simply)
               else if (pns^.Tip and SV_TYPE_WINDOWS <> 0) then begin
                  n.ImageIndex := 2;
                  n.SelectedIndex := 2;
                  n.StateIndex := 2;
               end
               else if (pns^.Tip and SV_TYPE_NT <> 0) then begin
                  n.ImageIndex := 1;
                  n.SelectedIndex := 1;
                  n.StateIndex := 1;
               end
               else if (pns^.Tip and SV_TYPE_WFW <> 0) then begin
                  n.ImageIndex := 3;
                  n.SelectedIndex := 3;
                  n.StateIndex := 3;
               end
               else begin
                  n.ImageIndex := 1;
                  n.SelectedIndex := 1;
                  n.StateIndex := 1;
               end;

               // Shares thread
               ShrThread := TShrThread.Create( True );
               ShrThread.computer := pns^.Name;
               ShrThread.Node := n;
               ShrThread.Resume;
               inc( ThreadCnt );
               ShrPath.Enabled := False;

               // Transports thread
               nn := Tree.Items.AddChild( n, 'Transport' );
               nn.ImageIndex := 13;
               nn.SelectedIndex := 13;
               nn.StateIndex := 13;
               TrpThread := TTrpThread.Create( True );
               TrpThread.computer := pns^.Name;
               TrpThread.Node := nn;
               TrpThread.Resume;
               inc( ThreadCnt );

               {
               // IP Thread
               IpThread := TIPThread.Create( True );
               IpThread.Computer := pns^.Name;
               IpThread.Node := n;
               IpThread.Resume;
               inc( ThreadCnt );
               }

            end;
         g.UnlockList;
      end;
   end;
   if Assigned( g ) then
      NW.FreeAndNilList( g );
end;

procedure TMain.MsgUsers( var AMessage: TMessage);
var
   ggg, n, parNode:        TTreeNode;
   g:                      TThreadLIst;
   q, i:                   cardinal;
   tmpS:                   string;
begin
   g := nil;
   if ( (AMessage.WParam <> 0) and (AMessage.LParam <> 0) ) then begin
      parNode := TTreeNode( AMessage.WParam );
      g := TThreadList( AMessage.LParam );
      with g.LockList do begin
         if Count > 0 then
            for i := 0 to Count - 1 do begin
               if Assigned( PMyNetUser(Items[i])^.Groups ) then begin
                  if PMyNetUser(Items[i])^.Groups.Count > 0 then begin
                     tmpS := 'Grp:';
                     for q := 0 to PMyNetUser(Items[i])^.Groups.Count - 1 do
                        tmpS := tmpS + '['+PMyGrpName( PMyNetUser(Items[i])^.Groups.Items[q] )^.Name+']';
                  end;
                  NW.FreeAndNilTList( PMyNetUser(Items[i])^.Groups );
               end;

               // Users will be added to his primary group only. (PMyNetUser(Items[l])^.gID)
               // But You can analize PMyNetUser(Items[l])^.Groups.Items[q] above
               // to sort users to all groups they belong.
               // Or use GetGroupUserInfo instead.
               ggg := FindGrp( parNode, PMyNetUser(Items[i])^.gID );
               if Assigned( ggg ) then
                  n := Tree.Items.AddChild( ggg, PMyNetUser(Items[i])^.Login+' ('+PMyNetUser(Items[i])^.Name+') '+tmpS )
               else
                  n := Tree.Items.AddChild( parNode, PMyNetUser(Items[i])^.Login+' ('+PMyNetUser(Items[i])^.Name+') '+tmpS );

               n.ImageIndex := 5;
               n.SelectedIndex := 5;
               n.StateIndex := 5;
            end;
         g.UnlockList;
      end;
   end;
   if Assigned( g ) then
      NW.FreeAndNilList( g );
end;

procedure TMain.MsgShares( var AMessage: TMessage);
var
   ggg, n, parNode:        TTreeNode;
   g:                      TThreadLIst;
   q, i:                   cardinal;
   tmpS:                   string;
begin
   g := nil;
   if ( (AMessage.WParam <> 0) and (AMessage.LParam <> 0) ) then begin
      parNode := TTreeNode( AMessage.WParam );
      g := TThreadList( AMessage.LParam );
      with g.LockList do begin
         if Count > 0 then
            for i := 0 to Count - 1 do begin
               n := Tree.Items.AddChild( parNode,  Main.NW.GetShareFromShareName(PMyNetResource(Items[i])^.RemoteName, False)+' ['+PMyNetResource(Items[i])^.RemotePath+'] ('+PMyNetResource(Items[i])^.Comment+')' );
               if PMyNetResource(Items[i])^.Tip = RESOURCETYPE_DISK then begin
                  n.ImageIndex := 7;
                  n.SelectedIndex := 7;
                  n.StateIndex := 7;
               end
               else if PMyNetResource(Items[i])^.Tip = RESOURCETYPE_PRINT then begin
                  n.ImageIndex := 8;
                  n.SelectedIndex := 8;
                  n.StateIndex := 8;
               end;
            end;
         g.UnlockList;
      end;
   end;
   if Assigned( g ) then
      NW.FreeAndNilList( g );
end;

procedure TMain.MsgTransports( var AMessage: TMessage);
var
   ggg, n, parNode:        TTreeNode;
   g:                      TThreadLIst;
   q, i:                   cardinal;
   tmpS:                   string;
begin
   g := nil;
   if ( (AMessage.WParam <> 0) and (AMessage.LParam <> 0) ) then begin
      parNode := TTreeNode( AMessage.WParam );
      g := TThreadList( AMessage.LParam );
      with g.LockList do begin
         if Count > 0 then
            for i := 0 to Count - 1 do begin
               n := Tree.Items.AddChild( parNode, PMyTransport(Items[i])^.Name+' ('+PMyTransport(Items[i])^.Addr+')'  );
               if PMyTransport(Items[i])^.Wan then
                  n.Text := n.Text + ' NetBIOS/TCIP'
               else
                  n.Text := n.Text + ' Net/BEUI or NetBIOS/IPX';
               n.ImageIndex := 14;
               n.SelectedIndex := 14;
               n.StateIndex := 14;
            end;
         g.UnlockList;
      end;
   end;
   if Assigned( g ) then
      NW.FreeAndNilList( g );
end;

procedure TMain.MsgIP( var AMessage: TMessage);
var
   n:                      TTreeNode;
   g:                      TIdTCPClient;
begin
   g := nil;
   if ( (AMessage.WParam <> 0) and (AMessage.LParam <> 0) ) then begin
      n := TTreeNode( AMessage.WParam );
      g := TIdTCPClient( AMessage.LParam );
      
      try
         if g.Connected then begin
            n.Text := n.Text +'['+g.Socket.Binding.PeerIP+']';
            g.Disconnect;
         end;   
      finally
         FreeAndNil( g );
      end;   
   end;
end;


// ---------- DomThread -----------------------
constructor TDomThread.Create(CreateSuspended: Boolean);
begin
   inherited;
end;

procedure TDomThread.Execute;
var
   i:              cardinal;
   d, dc:          TThreadList;
   ttt:            PMyNetResource;
begin
  dc := nil;
  try
     try
        what := 1; Synchronize( ShowInfo );

        // Domains
        if not Terminated then begin
           d := Main.NW.GetDomains;
            if Assigned( d ) then
               with d.LockList do begin
                  if Count > 0 then begin
                     for i := 0 to Count - 1 do begin

                        dom := PMyNetResource( Items[i] )^.RemoteName;
                        what := 2; Synchronize( ShowInfo );
                        // PDC for future use
                        // One way
                        if not Terminated then
                           pdc := Main.NW.GetPDC( PMyNetResource( Items[i] )^.RemoteName );
                           dc := TThreadList.Create;
                           GetMem( ttt, sizeof(TMyNetResource) );
                           ttt^.RemoteName := pdc;
                           with dc.LockList do begin
                              dc.Add( ttt );
                              dc.UnlockList;
                           end;

                        {
                        // Another way
                           dc := Main.NW.GetPDC_long_but_safely( PMyNetResource( Items[i] )^.RemoteName );

                        if Assigned( dc ) then
                           with dc.LockList do begin
                              if Count = 1 then
                                 pdc := PMyNetResource(Items[0])^.RemoteName;;
                              dc.UnlockList;
                           end;
                        }
                        what := 3; Synchronize( ShowInfo );

                        PostMessage( Main.Handle, PM_DOMAINS, integer(dc), integer(d) );

                     end; {for i := 0 to Count - 1 do begin}
                  end; {if Count > 0 then begin}
                  d.UnlockList;
               end; {with d.LockList do begin}
        end; {if not Terminated then begin}
     except
        on E: Exception do
     end;
  finally
     what := 99; Synchronize( ShowInfo );
     PostMessage( Main.Handle, PM_DOMTHREADDONE, integer( self ), 0 );
  end;
end;

procedure TDomThread.ShowInfo;
begin
   try
      case what of
         1: begin
            Main.ToLog('Finding domains...');
         end;
         2: begin
            Main.ToLog('Finding PDC for domain '+dom);
         end;
         3: begin
            Main.ToLog('PDC found for domain '+dom+' ['+pdc+']');
         end;
         99: begin
            Main.ToLog('GetDomain thread terminated');
         end;
      end; {case}
   finally
   end;
end;
// -------------------------------------------------------

// ---------- GrpThread -----------------------
constructor TGrpThread.Create(CreateSuspended: Boolean);
begin
   inherited;
end;

procedure TGrpThread.Execute;
var
   g:              TThreadList;
begin
  try
     try
        what := 1; Synchronize( ShowInfo );

        // Groups
        if not Terminated then begin
           g := Main.NW.GetGroups( pdc );
           if Assigned( g ) then
              PostMessage( Main.Handle, PM_GROUPS, integer(Node), integer(g) );
           what := 2; Synchronize( ShowInfo );
        end; {if not Terminated then begin}
     except
        on E: Exception do
     end;
  finally
     what := 99; Synchronize( ShowInfo );
     PostMessage( Main.Handle, PM_GRPTHREADDONE, integer( self ), integer(UsrThread) );
  end;
end;

procedure TGrpThread.ShowInfo;
begin
   try
      case what of
         1: begin
            Main.ToLog('Finding groups in domain '+dom);
         end;
         2: begin
            Main.ToLog('Groups found in domain '+dom);
         end;
         99: begin
            Main.ToLog('GetGroups thread for domain '+dom+' terminated');
         end;
      end; {case}
   finally
   end;
end;
// -------------------------------------------------------

// ---------- CmpThread -----------------------
constructor TCmpThread.Create(CreateSuspended: Boolean);
begin
   inherited;
end;

procedure TCmpThread.Execute;
var
   g:              TThreadList;
begin
  try
     try
        what := 1; Synchronize( ShowInfo );

        // Groups
        if not Terminated then begin
           // You can use GetUsers instead. GetUsers can return a users, Computers
           // Registered in domain. Computers return with "$" at end. For Example
           // MYCOMP$. Function GetServers return the working computers only, but
           // GetUsers return all registerd.
           g := Main.NW.GetServers( pdc, dom );
           if Assigned( g ) then
              PostMessage( Main.Handle, PM_COMPS, integer(Node), integer(g) );
           what := 2; Synchronize( ShowInfo );
        end; {if not Terminated then begin}
     except
        on E: Exception do
     end;
  finally
     what := 99; Synchronize( ShowInfo );
     PostMessage( Main.Handle, PM_CMPTHREADDONE, integer( self ), 0 );
  end;
end;

procedure TCmpThread.ShowInfo;
begin
   try
      case what of
         1: begin
            Main.ToLog('Finding computers in domain '+dom);
         end;
         2: begin
            Main.ToLog('Computers found in domain '+dom);
         end;
         99: begin
            Main.ToLog('GetComputers thread for domain '+dom+' terminated');
         end;
      end; {case}
   finally
   end;
end;
// -------------------------------------------------------

// ---------- UsrThread -----------------------
constructor TUsrThread.Create(CreateSuspended: Boolean);
begin
   inherited;
end;

procedure TUsrThread.Execute;
var
   g:              TThreadList;
begin
  try
     try
        what := 1; Synchronize( ShowInfo );

        // Groups
        if not Terminated then begin
           // You can use GetGroupUserInfo inseted. to obtain only login without
           // any Comments and primary group ID. For use GetGroupUserInfo You
           // can specify a group name and server.
           g := Main.NW.GetUsers( pdc, Main.UsrComment.Checked, Main.UsrGroups.Checked, FILTER_NORMAL_ACCOUNT );
           if Assigned( g ) then
              PostMessage( Main.Handle, PM_USERS, integer(Node), integer(g) );
           what := 2; Synchronize( ShowInfo );
        end; {if not Terminated then begin}
     except
        on E: Exception do
     end;
  finally
     what := 99; Synchronize( ShowInfo );
     PostMessage( Main.Handle, PM_USRTHREADDONE, integer( self ), 0 );
  end;
end;

procedure TUsrThread.ShowInfo;
begin
   try
      case what of
         1: begin
            Main.ToLog('Finding users in domain '+dom);
         end;
         2: begin
            Main.ToLog('Users found in domain '+dom);
         end;
         99: begin
            Main.ToLog('GetUsers thread for domain '+dom+' terminated');
         end;
      end; {case}
   finally
   end;
end;
// -------------------------------------------------------

// ---------- ShrThread -----------------------
constructor TShrThread.Create(CreateSuspended: Boolean);
begin
   inherited;
end;

procedure TShrThread.Execute;
var
   g:              TThreadList;
begin
  try
     try
        what := 1; Synchronize( ShowInfo );

        // Groups
        if not Terminated then begin
           g := Main.NW.GetShares('\\'+computer, Main.ShrPath.Checked, RESOURCETYPE_ANY );
           if Assigned( g ) then
              PostMessage( Main.Handle, PM_SHARES, integer(Node), integer(g) );
           what := 2; Synchronize( ShowInfo );
        end; {if not Terminated then begin}
     except
        on E: Exception do
     end;
  finally
     what := 99; Synchronize( ShowInfo );
     PostMessage( Main.Handle, PM_SHRTHREADDONE, integer( self ), 0 );
  end;
end;

procedure TShrThread.ShowInfo;
begin
   try
      case what of
         1: begin
            Main.ToLog('Finding shares on '+computer);
         end;
         2: begin
            Main.ToLog('Shares found on computer '+computer);
         end;
         99: begin
            Main.ToLog('GetShares thread for computer '+computer+' terminated');
         end;
      end; {case}
   finally
   end;
end;
// -------------------------------------------------------

// ---------- TrpThread -----------------------
constructor TTrpThread.Create(CreateSuspended: Boolean);
begin
   inherited;
end;

procedure TTrpThread.Execute;
var
   g:              TThreadList;
begin
  try
     try
        what := 1; Synchronize( ShowInfo );

        // Transports
        if not Terminated then begin
           g := Main.NW.GetTransport('\\'+computer );
           if Assigned( g ) then
              PostMessage( Main.Handle, PM_TRANSPORTS, integer(Node), integer(g) );
           what := 2; Synchronize( ShowInfo );
        end; {if not Terminated then begin}
     except
        on E: Exception do
     end;
  finally
     what := 99; Synchronize( ShowInfo );
     PostMessage( Main.Handle, PM_TRPTHREADDONE, integer( self ), 0 );
  end;
end;

procedure TTrpThread.ShowInfo;
begin
   try
      case what of
         1: begin
            Main.ToLog('Finding transports on '+computer);
         end;
         2: begin
            Main.ToLog('Transports found on computer '+computer);
         end;
         99: begin
            Main.ToLog('GetTransport thread for computer '+computer+' terminated');
         end;
      end; {case}
   finally
   end;
end;
// -------------------------------------------------------

// ---------- IpThread -----------------------
constructor TIpThread.Create(CreateSuspended: Boolean);
begin
   inherited;
end;

procedure TIpThread.Execute;
begin
  try
     try
        what := 1; Synchronize( ShowInfo );
        // Transports
        what := 0; Synchronize( ShowInfo );
     except
        on E: Exception do
     end;
  finally
     what := 99; Synchronize( ShowInfo );
     PostMessage( Main.Handle, PM_IPTHREADDONE, integer( self ), 0 );
  end;
end;

procedure TIpThread.ShowInfo;
var
   t:              TIdTCPClient;
begin
   try
      case what of
         0: begin
            if not Terminated then begin
               t := TIdTCPClient.Create( Main );
               t.Host := Computer;
               t.Port := 139;
               try
                  try
                     t.Connect();
                  except
                     on E: Exception do;
                  end;
               finally
                  PostMessage( Main.Handle, PM_TRANSPORTS, integer(Node), integer(t) );
               end;   
               what := 2; Synchronize( ShowInfo );
            end; {if not Terminated then begin}
         end;
         1: begin
            Main.ToLog('Detecting NetBIOS/TCPIP address of computer '+computer);
         end;
         2: begin
            Main.ToLog('NetBIOS/TCPIP address found on computer '+computer);
         end;
         99: begin
            Main.ToLog('GetIP thread for computer '+computer+' terminated');
         end;
      end; {case}
   finally
   end;
end;
// -------------------------------------------------------


procedure TMain.Button1Click(Sender: TObject);
var
   DomThread:        TDomThread;
   i:                cardinal;
begin
   Timer.Enabled := True;
   DomThread := TDomThread.Create( False );
   inc( ThreadCnt );
   Button1.Enabled := False;
   Tree.Items.Clear;
   Status.SimpleText := '';
   Log.Clear;
end;

function TMain.GetGID( str: string ): integer;
var
   cnt, i, j, qqq:                cardinal;
   sss:                           string;
begin
   Result := -1; cnt := 0; qqq := 0; j := 1;
   SetLength( sss, length( str ) );
   for i := 1 to length(str) do begin
      if Str[i] = '|' then
         inc( qqq )
      else if qqq = 1 then begin
         sss[j] := str[i];
         inc( cnt ); inc( j );
      end;

      if qqq >= 2 then begin
         SetLength( sss, cnt );
         Result := StrToIntDef( sss, -1 );
         exit;
      end;
   end;

end;

function TMain.FindGrp( g: TTreeNode; gID: integer ): TTreeNode;
var
   tmp:  TTreeNode;
begin
   Result := nil;
   tmp := g.getFirstChild;
   while Assigned( tmp ) do begin
      if GetGID( tmp.Text ) = gID then begin
         Result := tmp;
         exit;
      end
      else
         tmp := g.GetNextChild( tmp );
   end;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
   ThreadCnt := 0;
   User.Text := NW.MyUserName;
   Comp.Text := '\\'+NW.MyComputerName;
end;

procedure TMain.ToLog(str: string);
begin
   Status.Simpletext := str;
   Log.Lines.Add( '['+TimeToStr(Now)+']'+#9+str );
end;

procedure TMain.TimerTimer(Sender: TObject);
var
   str:   string;
begin
   str := 'Working. Please wait...';
   if ThreadCnt <= 0 then begin
      Wrk.Caption := 'Press "Go!" button';
      Timer.Enabled := False;
      Button1.Enabled := True;
      UsrGroups.Enabled := True;
      UsrComment.Enabled := True;
      ShrPath.Enabled := True;
   end
   else begin
      if ( (Wrk.Caption = 'Press "Go!" button') or (Wrk.Caption = 'Working. Please wait...') ) then
         Wrk.Caption := 'W'
      else
         Wrk.Caption := Wrk.Caption + str[ length(Wrk.Caption)+1 ];
   end;      
end;

procedure TMain.DNSStatus(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: String);
begin
   Status.simpleText := AStatusText;
end;

end.
